/*
lightOS libc
Copyright (C) 2006-2009 Jörg Pfähler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
#ifndef _LIGHTLIBC_STDIO_H
#define _LIGHTLIBC_STDIO_H


#include <lightlibc/compiler.h>

/*
 * Standard includes
 */
#include <stddef.h>                    // NOTE: NULL, size_t
#include <stdarg.h>                    // NOTE: va_list

/*
 * libc includes
 */
#include <libc/types.h>                // NOTE: _LIBC_fpos_t, _LIBC_FILE

/*
 * libOS includes
 */
#include <libOS/this/defines.h>        // NOTE: _LIBOS_L_tmpnam, _LIBOS_FILENAME_MAX,
                                       //       _LIBOS_FOPEN_MAX, _LIBOS_TMP_MAX


/** \addtogroup libc_stdio */
/*@{*/

/*
 * Defines
 * ISO/IEC 9899:1999 7.19.1
 */

/** Input/output fully buffered. */
#define _IONBF                         0
/** Input/output line buffered. */
#define _IOBF                          1
/** Input/output unbuffered. */
#define _IOLBF                         2

/** Size of <stdio.h> buffers. */
#define BUFSIZ                         512
/** End-of-file return value. */
#define EOF                            (int)-1

/** Seek relative to current position. */
#define SEEK_CUR                       0
/** Seek relative to end-of-file. */
#define SEEK_END                       1
/** Seek relative to start-of-file. */
#define SEEK_SET                       2

/** Standard error output stream. */
#define stdin                          (&_LIBOS_STDIN)
/** Standard input stream. */
#define stdout                         (&_LIBOS_STDOUT)
/** Standard output stream. */
#define stderr                         (&_LIBOS_STDERR)

/** Maximum size of character array to hold tmpnam() output. */
#define L_tmpnam                       _LIBOS_L_tmpnam

/** Maximum size in bytes of the longest filename string that
 *  the implementation guarantees can be opened. */
#define FILENAME_MAX                   _LIBOS_FILENAME_MAX
/** Number of streams which the implementation guarantees can
 *  be open simultaneously. The value is at least eight. */
#define FOPEN_MAX                      _LIBOS_FOPEN_MAX
/** Minimum number of unique filenames generated by tmpnam().
 *  Maximum number of times an application can call tmpnam() reliably.
 *  The value of TMP_MAX is at least 25.
 *  On XSI-conformant systems, the value of TMP_MAX is at least 10000. */
#define TMP_MAX                        _LIBOS_TMP_MAX


/*
 * Defines
 * IEEE Std 1003.1
 */
#ifndef _LIGHTLIBC_NO_POSIX

#define P_tmpdir                       "tmp://"

#endif


/*
 * Types
 * ISO/IEC 9899:1999 7.19.1
 */

/** Typedef the fpos_t type */
typedef _LIBC_fpos_t                   fpos_t;
/** Typedef the FILE type */
typedef _LIBC_FILE                     FILE;


/*
 * Extern variables
 */

#ifdef __cplusplus
  extern "C"
  {
#endif

    /** Declare the standard input stream
     *\note defined in libOS */
    extern FILE _LIBOS_STDIN;
    /** Declare the standard output stream
     *\note defined in libOS */
    extern FILE _LIBOS_STDOUT;
    /** Declare the standard error stream
     *\note defined in libOS */
    extern FILE _LIBOS_STDERR;

#ifdef __cplusplus
  }
#endif


/*
 * Functions
 */

#ifdef __cplusplus
  extern "C"
  {
#endif

    /*
     * ISO/IEC 9899:1999 7.19.4 Operations on files
     */

    /** ISO/IEC 9899:1999 7.19.4.1
     *
     *  The remove function causes the ﬁle whose name is the string pointed to by filename
     *  to be no longer accessible by that name. A subsequent attempt to open that ﬁle using that
     *  name will fail, unless it is created anew. If the ﬁle is open, the behavior of the remove
     *  function is implementation-deﬁned.
     *
     *  [CX] If path does not name a directory, remove(path) shall be equivalent to unlink(path).
     *       If path names a directory, remove(path) shall be equivalent to rmdir(path).
     *       http://www.opengroup.org/onlinepubs/000095399/functions/remove.html
     *\todo refers to unlink and rmdir
     *\todo implement
     *\param[in] filename path of the file to remove
     *\return The remove function returns zero if the operation succeeds, nonzero if it fails. */
    int remove(const char* filename);

    /** ISO/IEC 9899:1999 7.19.4.2
     *
     *  The rename function causes the ﬁle whose name is the string pointed to by old to be
     *  henceforth known by the name given by the string pointed to by new. The ﬁle named
     *  old is no longer accessible by that name. If a ﬁle named by the string pointed to by new
     *  exists prior to the call to the rename function, the behavior is implementation-deﬁned.
     *
     *  [CX] http://www.opengroup.org/onlinepubs/000095399/functions/rename.html
     *\todo implement
     *\param[in] oldname old filename
     *\param[in] newname new filename
     *\return The rename function returns zero if the operation succeeds, nonzero ([CX] -1) if it fails, in
     *        which case if the ﬁle existed previously it is still known by its original name.
     *        [CX] errno shall be set to indicate the error. */
    int rename(const char* oldname,
               const char* newname);

    /** ISO/IEC 9899:1999 7.19.4.3
     *
     *  The tmpfile function creates a temporary binary ﬁle that is different from any other
     *  existing ﬁle and that will automatically be removed when it is closed or at program
     *  termination. If the program terminates abnormally, whether an open temporary ﬁle is
     *  removed is implementation-deﬁned. The ﬁle is opened for update with "wb+" mode.
     *
     *  Recommended practice:
     *  It should be possible to open at least TMP_MAX temporary ﬁles during the lifetime of the
     *  program (this limit may be shared with tmpnam) and there should be no limit on the
     *  number simultaneously open other than this limit and any limit on the number of open
     *  ﬁles (FOPEN_MAX).
     *
     *  [CX] http://www.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
     *\return The tmpfile function returns a pointer to the stream of the ﬁle that it created. If the ﬁle
     *        cannot be created, the tmpfile function returns a null pointer.
     *        [CX] errno shall be set to indicate the error. */
    FILE* tmpfile(void);

    /** ISO/IEC 9899:1999 7.19.4.4
     *
     *  The tmpnam function generates a string that is a valid ﬁle name and that is not the same
     *  as the name of an existing ﬁle.227) The function is potentially capable of generating
     *  TMP_MAX different strings, but any or all of them may already be in use by existing ﬁles
     *  and thus not be suitable return values. The tmpnam function generates a different string
     *  each time it is called. The implementation shall behave as if no library function calls
     *  the tmpnam function.
     *
     *  [CX] http://www.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
     *\param[in,out] s space for the filename
     *\return If no suitable string can be generated, the tmpnam function returns a null pointer.
     *        Otherwise, if the argument is a null pointer, the tmpnam function leaves its result in an
     *        internal static object and returns a pointer to that object (subsequent calls to the tmpnam
     *        function may modify the same object). If the argument is not a null pointer, it is assumed
     *        to point to an array of at least L_tmpnam chars; the tmpnam function writes its result
     *        in that array and returns the argument as its value. */
    char* tmpnam(char* s);


    /*
     * ISO/IEC 9899:1999 7.19.5 File access functions
     */

    FILE* fopen(const char* filename,
                const char* mode);
    FILE* freopen(const char* path,
                  const char* mode,
                  FILE* stream);
    int fclose(FILE* stream);
    int fflush(FILE* stream);
    // TODO: void setbuf(FILE * _LIGHTLIBC_RESTRICT stream, char * _LIGHTLIBC_RESTRICT buf);
    // TODO: int setvbuf(FILE * _LIGHTLIBC_RESTRICT stream, char * _LIGHTLIBC_RESTRICT buf, int mode, size_t size);


    /*
     * ISO/IEC 9899:1999 7.19.6 Formatted input/output functions
     */

    int printf(const char* format,
               ...);
    int vprintf(const char* format,
                va_list arg);
    int fprintf(FILE* stream,
                const char* format,
                ...);
    int vfprintf(FILE* stream,
                 const char* format,
                 va_list arg);
    int sprintf(char* s,
                const char* format,
                ...);
    int vsprintf(char* s,
                 const char* format,
                 va_list arg);
    int snprintf(char* s,
                 size_t n,
                 const char* format,
                 ...);
    int vsnprintf(char* s,
                  size_t n,
                  const char* format,
                  va_list arg);

    int fscanf(FILE * _LIGHTLIBC_RESTRICT stream,
               const char * _LIGHTLIBC_RESTRICT format,
               ...);
    int scanf(const char * _LIGHTLIBC_RESTRICT format,
              ...);
    int sscanf(const char * _LIGHTLIBC_RESTRICT s,
               const char * _LIGHTLIBC_RESTRICT format,
               ...);
    int vfscanf(FILE * _LIGHTLIBC_RESTRICT stream,
                const char * _LIGHTLIBC_RESTRICT format,
                va_list arg);
    int vscanf(const char * _LIGHTLIBC_RESTRICT format,
               va_list arg);
    int vsscanf(const char * _LIGHTLIBC_RESTRICT s,
                const char * _LIGHTLIBC_RESTRICT format,
                va_list arg);


    /*
     * ISO/IEC 9899:1999 7.19.7 Character input/output functions
     */

    int fgetc(FILE* stream);
    char* fgets(char* s,
                int n,
                FILE* stream);
    #define getc(stream)               fgetc(stream)
    #define getchar(stream)            getc(stdin)
    #define gets(s)                    fgets(s, INT_MAX, stdin)

    int fputc(int c,
              FILE* stream);
    int fputs(const char* s,
              FILE* stream);
    int puts(const char* s);
    #define putc(c, stream)            fputc(c, stream)
    #define putchar(c)                 putc(c, stdout)
    int ungetc(int c,
               FILE* stream);


    /*
     * ISO/IEC 9899:1999 7.19.8 Direct input/output functions
     */

    size_t fread(void* ptr,
                 size_t size,
                 size_t nmemb,
                 FILE* stream);
    size_t fwrite(const void* ptr,
                  size_t size,
                  size_t nmemb,
                  FILE* stream);


    /*
     * ISO/IEC 9899:1999 7.19.9 File positioning functions
     */

    int fgetpos(FILE* stream,
                fpos_t* pos);
    int fseek(FILE* stream,
              long int offset,
              int whence);
    int fsetpos(FILE* stream,
                const fpos_t* pos);
    long int ftell(FILE* stream);
    void rewind(FILE* stream);


    /*
     * ISO/IEC 9899:1999 7.19.10 Error-handling functions
     */

    void clearerr(FILE* stream);
    int feof(FILE* stream);
    int ferror(FILE* stream);
    void perror(const char* s);


#ifdef __cplusplus
  }
#endif

/*@}*/


/*
 * Functions
 * IEEE Std 1003.1
 */

/*! \addtogroup libc_posix_stdio */
/*@{*/

#ifndef _LIGHTLIBC_NO_POSIX

#ifdef __cplusplus
  extern "C"
  {
#endif

  FILE* fdopen(int fildes,
               const char* mode);
  int fileno(FILE* stream);

#ifdef __cplusplus
  }
#endif

#endif

/*@}*/


#endif
